#include "libnazgul.h"
#include "ids.h"

// cree un nouvel elemen
int msgSpaceListElemCreate(
	msgSpaceListElemId elemenListId,
	msgSpace * space)
{

  msgSpaceId listElemId;

  strcpy(listElemId,space->id);
  int listElemFd;

  listElemFd=shm_open(listElemId,
	  O_RDWR|O_CREAT|O_EXCL|O_TRUNC,
	  SHM_DEFAULT_MODE);

  if (listElemFd == -1 ) {
	NZG_ERROR("shm_open : msgSpaceListElem creation",listElemId);
	goto ERROR;
  }

  if (ftruncate(listElemFd, sizeof(msgQueueElem)) < 0){
	NZG_ERROR("ftruncate", listElemId);
	goto ERROR;
  }

  close(listElemFd);
  return 0;
ERROR:
  return -1;

};
